$(document).ready(function() {
	
	tabData.sort();
	genererListeAct();
	var clipboard = new Clipboard('.bt_copier');
		
	/*==========================
	SAISIE ET CHOIX
	============================*/
	
	/* Gérer la liste déroulante Choix de l'activité + afficher du contenu dans les champs de saisie */
	$('body').on('change', '#choix_activite', function () {
		activiteEnCours = $("#choix_activite option:selected").val();
		if (activiteEnCours == "") {
			$('.saisie_tout').val("");
			$('#fichier_importe').hide();
			$('.bts_commencer').attr('disabled','disabled').removeClass('active');
		} else {
			afficherTexteAct(activiteEnCours);
			$('#fichier_importe').hide();
			$('.bts_commencer').removeAttr('disabled').addClass('active');
			nomDuFichier = $("#choix_activite option:selected").text();
		}
		if ( $('#saisie_aide').val() == "") $('.aide_jeu').hide();
		else $('.aide_jeu').show();
	});
	
	/* Gérer le bouton Importer */
	$('.bt_importer').click(function(){
		$('#fichier_importe').show();
	});
	
	/* Effacer tous les champs */
	$('.bt_effacer').click(function(){
		$('.saisie_tout').val("");
		$('.bts_commencer').attr('disabled','disabled').removeClass('active');
	});

	/* Masquer / Afficher les caractères */
	$('#masquer_caracteres').click(function(){
		$('#saisie_texte').toggleClass('texte_blanc');
		if ( $(this).html() == '<span class="glyphicon glyphicon-eye-close"></span> Masquer l\'activité') $(this).html('<span class="glyphicon glyphicon-eye-open"></span> Montrer l\'activité');
		else $(this).html('<span class="glyphicon glyphicon-eye-close"></span> Masquer l\'activité');
	});
	
	/* Editer l'activité avec des colonnes */
	$('.editer_activite').click(function(){
		modaleEditerActivite();
	});
	
	/* Valider l'activité éditée */
	$('#valider_edition').click(function(){
		recupererEdition();
	});
	
	/* Annuler l'activité éditée */
	$('#annuler_edition').click(function(){
		$('#modale_editer_activite').modal("hide");
	});
	
	/* Ajouter une colonne dans l'édition du texte */
	$('body').on('click', '.bt_ajouter_col', function () {
		$(this).parent().parent().parent().after(nouvelleColonne);
		if (clavieractif==true) installVKI();
	});
	
	/* Supprimer une colonne dans l'édition du texte */
	$('body').on('click', '.bt_supprimer_col', function () {
		$(this).parent().parent().parent().remove();
	});
	
	/* Exporter le texte => Ouvrir la fenêtre modale de saisie du nom de l'activité exportée */
	$('body').on('click', '.bt_exporter', function () {
		modaleExport();
	});
	
	/* Exporter le texte => exportation effective */
	$('body').on('click', '#valider_exporter', function () {
		 exporterTexte();
	});
	
	/*==========================
	CHANGEMENT D'ECRAN
	============================*/
	
	/* Déterminer le type de jeu : fixe ou animé */
	$('.gpe_boutons_commencer').click(function(){
		if ($(this).attr('id') == 'gpe_commencer_fixe') typeJeu = 'fixe';
		if ($(this).attr('id') == 'gpe_commencer_anime') typeJeu = 'anime';
	});
	
	/* Commencer le jeu : fixe et animé*/
	$(".gpe_boutons_commencer li").click(function() {
		$('.pave_j1').addClass('joueur_actif');
		if ( $('#saisie_consigne').val() != "" ) $('#affichage_consigne').html( $('#saisie_consigne').val() );
		if ( $('#saisie_aide').val() == "" ) $('#bt_aide').hide();
		$('.ecran_activite').show();
		$('.ecran_choix').hide();
		nbJoueurs = parseInt($(this).attr('data-nb_joueurs'));
		$('.pave_joueur').css('visibility','hidden');
		if (nbJoueurs == 1) $('.pave_j1').css('visibility','visible');
		if (nbJoueurs == 2) {
			$('.pave_j1').css('visibility','visible');
			$('.pave_j2').css('visibility','visible');
		}
		if (nbJoueurs == 3) $('.pave_joueur').css('visibility','visible');
		initialiserCommencer();
		if (typeJeu == 'fixe') {// si jeu fixe
			$('.ecran_fixe').show();
			$('.ecran_anime').hide();
			$('.zone_message span').html("<img src='images/logo_bonne_categorie_go.png' />");
			initialiseCompteur();
			afficherCarteFixe();
		} else {// si jeu animé
			$('.ecran_fixe').hide();
			$('.ecran_anime').show();
			$('.zone_message span').html("<img src='images/touche_gauche.png' class='scale_m005 pointer bt_gauche' /> <img src='images/touche_bas.png' class='scale_m005 pointer bt_enbas' style='margin:0 5px;' /> <img src='images/touche_droite.png' class='scale_m005 pointer bt_droite' />");
			modaleTempsReponse();
		}
	});
	
	/*==========================
	JEU FIXE
	============================*/
	
	/* Jeu fixe => Valider */
	$('body').on('click', '.mot_entete > div', function () {
		var motJuste = "<li class='mot_juste'>"+$('#affichage_motaclasser').text()+"</li>";
		var motFaux = "<li class='mot_faux'>"+$('#affichage_motaclasser').text()+"</li>";
		var dataCat = $(this).parent().attr('data-cat');
		var catego = $(this).parent().text().trim();
		var repAttendue = $('#affichage_motaclasser').children().attr('data-cat');
		
		var motAClasser = $('#affichage_motaclasser li').text().trim();
		var motClique = $(this).text().trim();
		var paireAttendue = motAClasser+"µ"+motClique;
		if (paireAttendue.indexOf('-µ-') != -1) {
			var paireCorrection = paireAttendue.replace('-µ-','');
			motJuste = "<li class='mot_juste'>"+paireCorrection+"</li>";
			motFaux = "<li class='mot_faux'>"+paireCorrection+"</li>";
		}
		
		nomJoueurEnCours = $('.pave_j'+joueurEnCours+' .saisie_nom').val();
		if (joueurEnCours == 1) nbEssaisJ1++;
		if (joueurEnCours == 2) nbEssaisJ2++;
		if (joueurEnCours == 3) nbEssaisJ3++;
		if ($.inArray(paireAttendue, tabPaires) != -1) {//réponse juste => la paire est dans le tableau
			$('#mots td.cat_'+dataCat).append(motJuste);
			marquerPointOui();
			if ( tabCatMotsToutes.length > 1 ) {
				tabCatMotsToutes.shift();
				$('#affichage_motaclasser').html(tabCatMotsToutes[0]);
			} else {//alert('plus de mots');
				tabCatMotsToutes.shift();
				$('#affichage_motaclasser').html('<img src="images/logo_partie_terminee.png" style="float:left;" />Félicitations ! La partie est terminée...<br /><button onclick="recommencerMemeTexte()" class="btn btn-info">Recommencer avec la même activité</button> <button onclick="recommencerAutreTexte()" class="btn btn-info">Recommencer avec une autre activité</button>');
				$('.zone_message span').html("<img src='images/logo_bonne_categorie_yes.png' />");
				$('.zone_message div').css('background','#FFF');
				$('.mot_entete button').attr('disabled','disabled');
				stopCount();
			}
			$('#nb_items_restants').text( (tabCatMotsToutes.length > 1) ? tabCatMotsToutes.length+' items à classer' : tabCatMotsToutes.length+' item à classer');
		}
		else {//réponse fausse
			marquerPointNon();
			$('#mots td.cat_'+dataCat).append(motFaux);
		}
		joueurSuivant();
		if (tabCatMotsToutes.length == 0) $('.pave_joueur').removeClass('joueur_actif').addClass('joueur_inactif');
	});
	
	/*==========================
	JEU ANIME
	============================*/
	
	/* Commencer le jeu animé via la modale => choix du temps de réponse du joueur */
	$('body').on('click', '.commencer_modale button', function () {
		tempsDeReponse = $(this).attr('data-delai');
		crescendo = $(this).attr('data-cre');
		initialiseCompteur();
		afficherCarteAnime();
		$('#modale_tempsdereponse').modal("hide");
	});
	
	/* Jeu animé => Gérer les clics sur les flèches */
	$('body').on('click', '.bt_bas', function () {
		versBas();
	});
	$('body').on('click', '.bt_haut', function () {
		versHaut();
	});
	$('body').on('click', '.bt_droite', function () {
		versDroite();
	});
	$('body').on('click', '.bt_gauche', function () {
		versGauche();
	});
	$('body').on('click', '.bt_enbas', function () {
		versEnBas();
	});
	$('body').bind('keydown', function(e) {
		var code = (e.keyCode ? e.keyCode : e.which);
		if (code == 37) versGauche();
		if (code == 39) versDroite();
		if (code == 40) versEnBas();
	});
	
	/*==========================
	ROUTINES
	============================*/
	
	/* Agrandir la taille de police dans le tableau du jeu */
	$('#agrandir').click(function(){
		var police = $('#zone_jeu_'+typeJeu).attr('data-taille');
		police = parseInt(police)+20;
		$('#zone_jeu_'+typeJeu).css('font-size',police+'%');
		$('#zone_jeu_'+typeJeu).attr('data-taille',police);
	});
	
	/* Réduire la taille de police dans le tableau de jeu */
	$('#reduire').click(function(){
		var police = $('#zone_jeu_'+typeJeu).attr('data-taille');
		if (police >= 40) {
			police = parseInt(police)-20;
			$('#zone_jeu_'+typeJeu).css('font-size',police+'%');
			$('#zone_jeu_'+typeJeu).attr('data-taille',police);
		}
	});

	/* Gérer les plier déplier */
	$('body').on('click', '.plier_deplier_simple', function () {
		$(this).next().slideToggle();
	});	
	
	/* Afficher en page complète la fenêtre Comment jouer, pour impression */
	$('body').on('click', '#voir_doc', function () {
		$('.ecran_choix').hide();
		$('#modale_comment_jouer').modal("hide");
		var contenu_doc = $('#div_comment_jouer').html();
		$('#imprimer_doc').html(contenu_doc).show();
		$('#imprimer_doc .plier_deplier_simple').next().css('display','block').css('background-color','#FFF');
	});
	
	/* Repasser de la page de la doc à l'application */
	$('body').on('click', '#retour_application', function () {
		$('.ecran_choix').show();
		$('#imprimer_doc').hide();
		$('#saisie_texte').focus();
	});
	
	// Afficher l'aide du volet des contributions en toogle
	$('.afficher_info_contribution').click(function(){
		$(this).parent().next().slideToggle();
	});
	
	// Afficher le volet des contributions en toogle
	$('#fleche_volet_contribution').click(function(){
		if ($(this).attr("src") == "images/icone_vers_haut_24.png") {
			$(this).attr("src","images/icone_vers_bas_24.png");
			$("#volet_contribution").slideUp();
		} else {
			$(this).attr("src","images/icone_vers_haut_24.png");
			$("#volet_contribution").slideDown();
		}
	});
	
	
}); // Fin $(document).ready(function()

/* -------------------------------------------------------
DECLARATION DES VARIABLES
---------------------------------------------------------- */

var nomDuFichier = "";
var nbJoueurs = 1; 
var joueurEnCours = 1;
var nomJoueurEnCours = "";
var nbPtsJ1 = 0;
var nbPtsJ2 = 0;
var nbPtsJ3 = 0;
var nbEssaisJ1 = 0;
var nbEssaisJ2 = 0;
var nbEssaisJ3 = 0;
var compte = 0;
var temps;
var timer_is_on = 0;
var compteur = 0;
var activiteEnCours = "";
var typeJeu = "";
var tabCatMots = [];
var tabCatMotsToutes = [];
var tabPaires = [];
var nbColonnes = 0;
var catAttendue = "";
var colAleatoire = 0;
var ligneEnCours = "";
var colonneEnCours = "";
var catColonne = "";
var ligneColonne = [0,0];
var tempsDeReponse = 3000;
var crescendo = "non";
var tempsJoueur = 0;
var intervalTimer = 0;
var intervalDescente = 0;
var nouvelleColonne = "<div class='col-lg-3 col-md-3 col-sm-3 col-xs-6 col_a_editer'><div> <div><img class='bt_supprimer_col pointer scale_p005' title='Supprimer cette catégorie' src='images/icone_moins_24.png' /> <img class='bt_ajouter_col pointer scale_p005' title='Ajouter une catégorie' src='images/icone_plus_24.png' /></div> <textarea class='form-control claviable' id='plop123' lang='fr' placeholder=\"Saisir un terme par ligne : la catégorie suivie des éléments lui appartenant. Si la catégorie est la seconde partie d'un mot, la faire précéder de - et ajouter - à ses premières parties possibles.\"></textarea> </div></div>";

/* -------------------------------------------------------
FONCTIONS
---------------------------------------------------------- */

/*==========================
GESTION DU CLAVIER
============================*/

/* Afficher ou non le clavier virtuel */
function afficherClavier() {
	if ( $('#gerer_clavier img').attr('src') == 'images/logo_clavier_24_off.png'  ) {
		$('#gerer_clavier').html('<img src="images/logo_clavier_24_on.png" />').attr('title','Désactiver le clavier virtuel');
		installVKI();
	} else {
		$('#gerer_clavier').html('<img src="images/logo_clavier_24_off.png" />').attr('title','Activer le clavier virtuel');
		desinstallVKI();
	}
}

/*==========================
SAISIE ET CHOIX
============================*/

/* Génération de la liste des activités et affichage dans le select */
function genererListeAct() {
	var listeActivites = "<option value=''>--- Choisir une activité ---</option>";
	for (i=0 ; i<tabData.length ; i++ ) {
		listeActivites += "<option value='"+i+"'>"+tabData[i][0]+"</option>";
	}
	$('#choix_activite').html(listeActivites);
}

/* Affichage du contenu de l'activité */
function afficherTexteAct(serie) {
	var tabTexte = [];
	var letexte = "";
	for (i=0 ; i < tabData[serie][1].length ; i++) {
		tabTexte.push(tabData[serie][1][i].trim());
	}
	$('#champ_contenu_cache').html(tabTexte.join("\n"));
	var laconsigne = tabTexte[0];
	if (laconsigne.indexOf('#consigne#') == 0) laconsigne = laconsigne.replace('#consigne#','').trim();
	tabTexte.shift();
	var laide = tabTexte[0];
	if (laide.indexOf('#aide#') == 0) laide = laide.replace('#aide#','').trim();
	tabTexte.shift();
	letexte = tabTexte.join("\n");
	$('#saisie_consigne').val(laconsigne);
	$('#saisie_aide').val(laide);
	$('#saisie_texte').val(letexte);
	siContenuModifie();
}

/* Vérification de la validité des données pour que le classement soit possible */
function validiteContenu() {// on s'assure qu'il existe au moins 2 lignes valides et aucune non valides
	var lignesValides = 0;
	var lignesNonValides = 0;
	var leContenu = $('#saisie_texte').val();
	var tabContenu = leContenu.split('\n');
	tabContenu = tabContenu.filter( function(val){ return val != '' && val.substring(0,1) != '#' } ); // on ignore les lignes vides et les lignes commençant par #
	for (i=0 ; i < tabContenu.length ; i++) {
		tabContenu[i] = tabContenu[i].replace(/ /g,"");
		var test = tabContenu[i].match(/.+;.+/gi);
		if (test == null) lignesNonValides++;
		else lignesValides++;
	}
	if (lignesValides > 1 && lignesNonValides == 0) return true;
}

/* Gestion de la modification des champs de saisie */
function siContenuModifie() {
	var contenuActivite = "";
	if ($('#saisie_consigne').val() != "") contenuActivite = "#consigne#"+$('#saisie_consigne').val()+"\n";
	else contenuActivite = $('#saisie_consigne').val()+"\n";
	if ($( '#saisie_aide').val() != "") {
		contenuActivite += "#aide#"+$('#saisie_aide').val()+"\n";
		$('.aide_jeu').show();
	} else {
		contenuActivite += $('#saisie_aide').val()+"\n";
		$('.aide_jeu').hide();
	}
	contenuActivite += $('#saisie_texte').val();
	$('#champ_contenu_cache').val(contenuActivite);
	if (validiteContenu() != true) $('.bts_commencer').attr('disabled','disabled').removeClass('active');
	else $('.bts_commencer').removeAttr('disabled').addClass('active');
}

/* Récupérer dans le champ de saisie les colonnes éditées */
function recupererEdition() {
	$('#saisie_texte').val('');
	var texteARecuperer = "";
	$(".col_a_editer").each(function(){
		var texteSaisi = $(this).find('textarea').val();
		var tabColonne = texteSaisi.split('\n');
		tabColonne = tabColonne.filter( function(val){ return val != '' && val.substring(0,1) != '#' } );
		var texteCat = tabColonne.join(' ; ');
		if (texteCat != "") texteARecuperer += texteCat+"\n";
    });
	$('#saisie_texte').val(texteARecuperer);
	$('#modale_editer_activite').modal("hide");
	siContenuModifie();
}

/* Récupération des fichiers importés */
function importer() {
	var reader = new FileReader();
	reader.onload = function (e) {
		contenuImporte=e.target.result;
		var tabContenu = contenuImporte.split("\r\n");
		
		for (i = 0; i < tabContenu.length; i++) {
			if (tabContenu[i].indexOf('#consigne#') == 0) var laconsigne = tabContenu[i].replace('#consigne#','').trim();
			if (tabContenu[i].indexOf('#aide#') == 0) var laide = tabContenu[i].replace('#aide#','').trim();
		}

		tabContenu = tabContenu.filter( function(val){ return val != '' && val.substring(0,1) != '#' } ); // on ignore les lignes vides et les lignes commençant par #
		var letexte = tabContenu.join('\n');
		$('#saisie_consigne').val(laconsigne);
		$('#saisie_aide').val(laide);
		$('#saisie_texte').val(letexte);
		if (validiteContenu() != true) $('.bts_commencer').attr('disabled','disabled').removeClass('active');
		else $('.bts_commencer').removeAttr('disabled').addClass('active');
	}
	reader.readAsText($('#fichier_importe').prop('files')[0], 'ISO-8859-1');
	$('#fichier_importe').hide();
	nomDuFichier = "";
}

/* Exporter le texte */
function exporterTexte() {
	nomDuFichier = $('#saisie_nom_fichier').val();
	nomDuFichier = nomDuFichier.replaceAll(' ','-');
	nomDuFichier = nomDuFichier.replaceAll('*','-');
	nomDuFichier = nomDuFichier.replaceAll('|','-');
	nomDuFichier = nomDuFichier.replaceAll('/','-');
	nomDuFichier = nomDuFichier.replaceAll(':','-');
	nomDuFichier = nomDuFichier.replaceAll('"','-');
	nomDuFichier = nomDuFichier.replaceAll('<','-');
	nomDuFichier = nomDuFichier.replaceAll('>','-');
	nomDuFichier = nomDuFichier.replaceAll('?','-');
	if (nomDuFichier != "") {
		$('#nomFichier').val(nomDuFichier+".txt");
		$('#saisie_activite').submit();
		$('#modale_exporter').modal("hide");
		return false;
	} else alert("Oups ! Merci de saisir un nom de fichier...");
}

/*==========================
CHANGEMENT D'ECRAN
============================*/

/* Initialisation du jeu en cliquant sur Commencer */
function initialiserCommencer() {
	$('#fin_jeu_anime').hide();
	tabCatMots = [];
	tabCatMotsToutes = [];
	tabPaires = [];
	nbPtsJ1 = 0, nbPtsJ2 = 0, nbPtsJ3 = 0;
	nbEssaisJ1 = 0, nbEssaisJ2 = 0, nbEssaisJ3 = 0;
	nomJoueurEnCours = "Joueur 1";
	$('.score').text(0);
	$('#entetes').html("");
	$('#mots').html("");
	joueurEnCours = 1;
	$('.pave_joueur').removeClass('joueur_actif').addClass('joueur_inactif');
	$('.pave_j1').removeClass('joueur_inactif').addClass('joueur_actif');
	if ( $('#saisie_aide').val() == "") $('#aide_jeu').hide();
	else $('#aide_jeu').show();
	tempsJoueur = 60;
	$("#ligne_0 td").removeClass('faux');
	// initialiserVKI();
}

/* Recommencer avec la même activité */
function recommencerMemeTexte() {
	$('.ecran_choix').show();
	$('.ecran_activite').hide();
	$('.zone_message div').css('background-color','#FFF');
	$('.zone_message span').text('');
	$('#fin_jeu_anime').hide();
	$('.ecran_anime table').hide();
	ligneColonne=[0,0];
	clearInterval(intervalDescente);
	stopCount();
	$('#compteur').text('00:00');
	clearInterval(intervalTimer);
	tempsJoueur = 60;
	$('#temps_joueur').text('0');
}

/* Recommencer avec une autre activité */
function recommencerAutreTexte() {
	recommencerMemeTexte();
	$('#choix_activite').val("");
	$('.saisie_tout').val("");
	$('.bts_commencer').removeClass('active').attr('disabled','disabled');
}

/* Jeu animé => Continuer */
function continuerAnime() {
	$('#fin_jeu_anime').hide();
	$('.ecran_anime table').hide();
	joueurSuivant();
	afficherCarteAnime();
	if (crescendo == 'oui') tempsDeReponse = 4000;
	initialiserDescente();
	ligneColonne=[0,0];
}

/*==========================
JEU FIXE
============================*/

/* Jeu fixe => Affichage du tableau */
function afficherCarteFixe() {
	
	var enteteCat = [];
	var leContenu = $('#saisie_texte').val();
	var tabContenu = leContenu.split('\n');
	tabContenu = tabContenu.filter( function(val){ return val != '' && val.substring(0,1) != '#' } ); // on ignore les lignes vides et les lignes commençant par #
	
	if (tabContenu.length > 7) {
		shuffle(tabContenu);
		tabContenu = tabContenu.slice(0,8);
		tabContenu.sort();
	}
	var largeurColonne = Math.floor(100/tabContenu.length)+"%";
	
	for (i = 0; i < tabContenu.length ; i++) {
		var catMotsTmp = tabContenu[i];
		tabCatMots[i] = catMotsTmp.split(';');
		
		var tabPairesTmp = [];
		for (j = 0; j < tabCatMots[i].length; j++) {
			tabPairesTmp.push(tabCatMots[i][j].trim()+"µ"+tabCatMots[i][0].trim());
		}
		tabPairesTmp.shift();
		for (j = 0; j < tabPairesTmp.length; j++) {
			tabPaires.push(tabPairesTmp[j]);
		}
		
		enteteCat[i] = tabCatMots[i][0];//on crée le tableau des entêtes

		for (j = 0; j < tabCatMots[i].length; j++) {// on crée un tableau de mots pour chaque catégorie
			tabCatMots[i][j] = "<li data-cat='"+enteteCat[i].trim()+"'>"+tabCatMots[i][j].trim()+"</li>";
		}
		tabCatMots[i].shift();
		
		for (j = 0; j < tabCatMots[i].length; j++) {
			tabCatMotsToutes.push(tabCatMots[i][j]);
		}
	}
	
	shuffle(tabCatMotsToutes);
	if (tabCatMotsToutes.length > 17) tabCatMotsToutes = tabCatMotsToutes.slice(0,18);// on limite de nombre d'items à 18
	
	$("#affichage_motaclasser").html(tabCatMotsToutes[0]);
	for (i=0 ; i < tabContenu.length ; i++) {
		$('#entetes').append("<td class='mot_entete cat_"+i+"' data-cat='"+i+"' style='width:"+largeurColonne+";'><div class='faux_bt ombre_cote_5 pointer'>"+enteteCat[i]+"</div></td>");
		$('#mots').append("<td class=cat_"+i+"></td>");
	}
	$('#nb_items_restants').text( (tabCatMotsToutes.length > 1) ? tabCatMotsToutes.length+' items à classer' : tabCatMotsToutes.length+' item à classer');

}

/* Jeu fixe => Marquer un point */
function marquerPointOui() {
	$('.zone_message div').css('background-color','#96FF96');
	$('.zone_message span').html('<b>Bravo '+nomJoueurEnCours+' !</b>');
	var zone = '.pave_j'+joueurEnCours;
	if (joueurEnCours == 1) {
		nbPtsJ1++;
		var pourcentage = Math.ceil(nbPtsJ1 / nbEssaisJ1 * 100);
		$(zone+' .score').text(pourcentage);
	}
	if (joueurEnCours == 2) {
		nbPtsJ2++;
		var pourcentage = Math.ceil(nbPtsJ2 / nbEssaisJ2 * 100);
		$(zone+' .score').text(pourcentage);
	}
	if (joueurEnCours == 3) {
		nbPtsJ3++;
		var pourcentage = Math.ceil(nbPtsJ3 / nbEssaisJ3 * 100);
		$(zone+' .score').text(pourcentage);
	}
}

/* Jeu fixe => Ne pas marquer de point */
function marquerPointNon() {
	$('.zone_message div').css('background-color','#FFCACA');
	$('.zone_message span').html('<b>Dommage '+nomJoueurEnCours+' !</b>');
	var zone = '.pave_j'+joueurEnCours;
	if (joueurEnCours == 1) {
		var pourcentage = Math.ceil(nbPtsJ1 / nbEssaisJ1 * 100);
		$(zone+' .score').text(pourcentage);
	}
	if (joueurEnCours == 2) {
		var pourcentage = Math.ceil(nbPtsJ2 / nbEssaisJ2 * 100);
		$(zone+' .score').text(pourcentage);
	}
	if (joueurEnCours == 3) {
		var pourcentage = Math.ceil(nbPtsJ3 / nbEssaisJ3 * 100);
		$(zone+' .score').text(pourcentage);
	}
}

/*==========================
JEU ANIME
============================*/

/* Jeu animé => Affichage du tableau */
function afficherCarteAnime() {
	
	initialiserTimer();
	initialiserDescente();
	startCount();
	$('.ecran_anime table').show();
	$('#zone_jeu_anime tr').html('');
	$('#zone_jeu_anime table').addClass('jeu_anime');
	$('#fin_jeu_anime').hide();
	var enteteCat = [];
	var leContenu = $('#saisie_texte').val();
	var tabContenu = leContenu.split('\n');
	tabContenu = tabContenu.filter( function(val){ return val != '' && val.substring(0,1) != '#' } ); // on ignore les lignes vides et les lignes commençant par #
	
	if (tabContenu.length > 7) {// si plus de 8 catégorie, on mélange et en conserve 8
		shuffle(tabContenu);
		tabContenu = tabContenu.slice(0,8);
		tabContenu.sort();
	}
	nbColonnes = tabContenu.length;
	var largeurColonne = Math.floor(100/tabContenu.length)+"%";
	
	for (i = 0; i < tabContenu.length ; i++) {
		var catMotsTmp = tabContenu[i];
		tabCatMots[i] = catMotsTmp.split(';');
		
		var tabPairesTmp = [];
		for (j = 0; j < tabCatMots[i].length; j++) {
			tabPairesTmp.push(tabCatMots[i][j].trim()+"µ"+tabCatMots[i][0].trim());
		}
		tabPairesTmp.shift();
		for (j = 0; j < tabPairesTmp.length; j++) {
			tabPaires.push(tabPairesTmp[j]);
		}
		
		enteteCat[i] = tabCatMots[i][0];//on crée le tableau des entêtes
		for (j = 0; j < tabCatMots[i].length; j++) {// on crée un tableau de mots pour chaque catégorie
			tabCatMots[i][j] = "<li data-cat='"+enteteCat[i].trim()+"' data-motaclasser='"+tabCatMots[i][j].trim()+"'>"+tabCatMots[i][j].trim()+"</li>";
		}
		tabCatMots[i].shift();
		
		for (j = 0; j < tabCatMots[i].length; j++) {
			tabCatMotsToutes.push(tabCatMots[i][j]);
		}
	}
	shuffle(tabCatMotsToutes);
	
	for (i=0 ; i < tabContenu.length && i < nbColonnes ; i++) {
		$('tr.ligne').append("<td data-td="+i+" class='case cache col_"+i+"' style='width:"+largeurColonne+";'></td>");
		$('#ligne_6').append("<td class='faux col_"+i+"' style='background:#5D5D5D; font-weight:bold;'>"+enteteCat[i]+"</td>");
		$('#ligne_7').append("<td class='rep_juste col_"+i+"'></td>");
	}
	$(".case").html(tabCatMotsToutes[0]);// on affiche l'item dans toutes les cellules
	$("#ligne_0 .col_0").removeClass('cache').addClass('visible');
	catAttendue = $('#ligne_0 .col_0 li').attr('data-cat').trim();
}

/* Jeu animé => Déplacement en haut (utile uniquement pour les tests) */
function versHaut() {
	var lignePrecedente = ligneColonne[0]-1;
	$("#ligne_"+ligneColonne[0]+" .col_"+ligneColonne[1]).removeClass('visible').addClass('cache');
	$("#ligne_"+lignePrecedente+" .col_"+ligneColonne[1]).removeClass('cache').addClass('visible');
	if ( $("#ligne_"+ligneColonne[0]+" .col_"+ligneColonne[1]).hasClass('faux') ) $("#ligne_"+ligneColonne[0]+" .col_"+ligneColonne[1]).removeClass('cache');
	ligneColonne = [lignePrecedente,ligneColonne[1]];
}

/* Jeu animé => Déplacement à droite */
function versDroite() {
	var colonneSuivante = (ligneColonne[1]+1)%nbColonnes;
	if ( !$(".jeu_anime #ligne_"+ligneColonne[0]+" .col_"+colonneSuivante).hasClass('faux') ) {
		$(".jeu_anime #ligne_"+ligneColonne[0]+" .col_"+ligneColonne[1]).removeClass('visible').addClass('cache');
		$(".jeu_anime #ligne_"+ligneColonne[0]+" .col_"+colonneSuivante).removeClass('cache').addClass('visible');
		if ( $(".jeu_anime #ligne_"+ligneColonne[0]+" .col_"+ligneColonne[1]).hasClass('faux') ) $(".jeu_anime #ligne_"+ligneColonne[0]+" .col_"+ligneColonne[1]).removeClass('cache');
		ligneColonne = [ligneColonne[0],colonneSuivante];
	}
}

/* Jeu animé => Déplacement à gauche */
function versGauche() {
	var colonnePrecedente = (ligneColonne[1]+nbColonnes-1)%nbColonnes;
	if ( !$(".jeu_anime #ligne_"+ligneColonne[0]+" .col_"+colonnePrecedente).hasClass('faux') ) {
		$(".jeu_anime #ligne_"+ligneColonne[0]+" .col_"+ligneColonne[1]).removeClass('visible').addClass('cache');
		$(".jeu_anime #ligne_"+ligneColonne[0]+" .col_"+colonnePrecedente).removeClass('cache').addClass('visible');
		if ( $(".jeu_anime #ligne_"+ligneColonne[0]+" .col_"+ligneColonne[1]).hasClass('faux') ) $(".jeu_anime #ligne_"+ligneColonne[0]+" .col_"+ligneColonne[1]).removeClass('cache');
		ligneColonne = [ligneColonne[0],colonnePrecedente];
	}
}

/* Jeu animé => Déplacement en bas */
function versBas() {
	var ligneSuivante = ligneColonne[0]+1;
	var catColonne = $(".jeu_anime #ligne_6 .col_"+ligneColonne[1]).text().trim();
	if ( !$(".jeu_anime #ligne_"+ligneSuivante+" .col_"+ligneColonne[1]).hasClass('faux') ) {// si la ligne suivante n'a pas la classe faux
		$(".jeu_anime #ligne_"+ligneColonne[0]+" .col_"+ligneColonne[1]).removeClass('visible').addClass('cache');
		$(".jeu_anime #ligne_"+ligneSuivante+" .col_"+ligneColonne[1]).removeClass('cache').addClass('visible');
		ligneColonne = [ligneSuivante,ligneColonne[1]];
	} else {
		versEnBas();
	}
}

/* Jeu animé => Déplacement directement en bas (en fait validation) */
function versEnBas() {
	for (i=6 ; i>0 ; i--) {
		if ( $(".jeu_anime #ligne_"+i+" .col_"+ligneColonne[1]).hasClass('faux') ) var premiereLigneFaux = i;
	}
	var ligneFausse = premiereLigneFaux-1;
	var catColonne = $(".jeu_anime #ligne_6 .col_"+ligneColonne[1]).text().trim();
	var motAClasser = $(".jeu_anime #ligne_0 .col_0 li").attr('data-motaclasser');
	var paireAttendue = motAClasser+"µ"+catAttendue;
	var paireChoisie = motAClasser+"µ"+catColonne;
	
	if ($.inArray(paireChoisie, tabPaires) != -1) {//réponse juste => la paire est dans le tableau => gagné
		
		if (paireAttendue.indexOf('-µ-') != -1) {
			var paireCorrection = paireAttendue.replace('-µ-','');
			$(".jeu_anime #ligne_7 .col_"+ligneColonne[1]).prepend("<li>"+paireCorrection+"</li>");
		} else $(".jeu_anime #ligne_7 .col_"+ligneColonne[1]).prepend("<li>"+tabCatMotsToutes[0]+"</li>");
		
		marquerPointAnime();
		$('.zone_message div').css('background-color','#96FF96');
		tabCatMotsToutes.push(tabCatMotsToutes[0]);
		tabCatMotsToutes.shift();
		$(".jeu_anime td.case:not(.faux)").html(tabCatMotsToutes[0]).addClass('cache').removeClass('visible');
		$(".jeu_anime #ligne_0 .col_"+colAleatoire).removeClass('cache').addClass('visible');
		catAttendue = $('.jeu_anime #ligne_0 .col_'+colAleatoire+' li').attr('data-cat').trim();
		ligneColonne = [0,colAleatoire];
		if (crescendo == 'oui' && tempsDeReponse > 500) {// Avec le choix crescendo, le délai se réduit de 20% à chaque bonne réponse tant qu'il est supérieur à 500
			tempsDeReponse = Math.ceil(tempsDeReponse * 0.8);
			initialiserDescente();
		}
	} else {// réponse fausse => perdu
		$('.zone_message div').css('background-color','#FFCACA');
		$(".jeu_anime #ligne_"+ligneFausse+" .col_"+ligneColonne[1]).removeClass('cache').addClass('faux');	
		
		if (paireAttendue.indexOf('-µ-') != -1) {
			var paireCorrection = paireChoisie.replace('-µ-','');
			if ( $(".jeu_anime #ligne_"+ligneFausse+" td").hasClass('faux')) $(".jeu_anime #ligne_"+ligneFausse+" td.col_"+ligneColonne[1]+"").html("<li data-cat='"+catAttendue+"' data-motaclasser='"+motAClasser+"'>"+paireCorrection+"</li>").addClass('visble').removeClass('cache');;
			$(".jeu_anime td.case:not(.faux)").addClass('cache').removeClass('visible');		
		} else $(".jeu_anime td.case:not(.faux)").html("<li data-cat='"+catAttendue+"' data-motaclasser='"+motAClasser+"'>"+motAClasser+"</li>").addClass('cache').removeClass('visible');

		$(".jeu_anime #ligne_0 .col_"+colAleatoire).removeClass('cache').addClass('visible');
		ligneColonne = [0,colAleatoire];
	}
	colAleatoire = Math.floor(Math.random() * nbColonnes);

}

/* Jeu animé => Gestion de la descente de l'item */
function gererDescente() {
	if (tempsJoueur <= 0 || $("#ligne_0 td").hasClass('faux')) {// la partie se termine => fini !
		clearInterval(intervalTimer);
		clearInterval(intervalDescente);
		stopCount();
		$('#temps_joueur').text(0);
		$("#zone_jeu_anime table td").each(function(){
			if ( $(this).hasClass('visible') && !$(this).hasClass('faux') ) $(this).removeClass('visible').html('');
		});
		$('#zone_jeu_anime table').removeClass('jeu_anime');
		var numJoueurSuivant = ((joueurEnCours + nbJoueurs) % nbJoueurs ) + 1;
		var nomJoueurSuivant = $('.pave_j'+numJoueurSuivant+' .saisie_nom').val();
		$('#fin_jeu_anime').html("<img src='images/logo_partie_terminee.png' style='float:left;' />Série terminée !<br /><button class='btn btn-primary' onclick='continuerAnime()'>à "+nomJoueurSuivant+"</button> <button class='btn btn-info' onclick='recommencerMemeTexte()'>Recommencer avec la même activité</button> <button class='btn btn-info' onclick='recommencerAutreTexte()'>Recommencer avec une autre activité</button>").show();
	}
	else versBas();
}
function initialiserDescente() {
	clearInterval(intervalDescente);
	intervalDescente = setInterval(function(){ gererDescente() }, tempsDeReponse);
	$('#delai_chgt_ligne').text(tempsDeReponse);
}

/* Jeu animé => Marquer un point */
function marquerPointAnime() {
	var zone = '.pave_j'+joueurEnCours;
	if (joueurEnCours == 1) {
		nbPtsJ1++;
		$(zone+' .score').text(nbPtsJ1);
	}
	if (joueurEnCours == 2) {
		nbPtsJ2++;
		$(zone+' .score').text(nbPtsJ2);
	}
	if (joueurEnCours == 3) {
		nbPtsJ3++;
		$(zone+' .score').text(nbPtsJ3);
	}
}

/* Jeu animé => Affichage du temps de jeu d'une partie (compte à rebours) */
function gererTimer() {
	$('#temps_joueur').text(tempsJoueur);
	tempsJoueur--;
}
function initialiserTimer() {
	clearInterval(intervalTimer);
	tempsJoueur = 60;
	intervalTimer = setInterval(function(){ gererTimer() }, 1000);
}

/*==========================
ROUTINES
============================*/

/* Passage au joueur suivant */
function joueurSuivant() {
	joueurEnCours = ( (joueurEnCours + nbJoueurs) % nbJoueurs ) + 1;
	$('.pave_joueur').removeClass('joueur_actif').addClass('joueur_inactif');
	$('.pave_j'+joueurEnCours).removeClass('joueur_inactif').addClass('joueur_actif');
}

/* Compteur du temps écoulé pour la partie */

function timedCount() {
	var secondes=new Date();
	secondes.setTime(compte*1000);
	var lesMinutes = secondes.getMinutes();
	var lesSecondes = secondes.getSeconds();
	lesMinutes=lesMinutes.toString().replace(/^(\d)$/,'0$1')
	lesSecondes=lesSecondes.toString().replace(/^(\d)$/,'0$1')
	compteur= lesMinutes+":"+lesSecondes;
	$("#compteur").text(compteur);
	compte = compte + 1;
	temps = setTimeout(function(){ timedCount() }, 1000);
}

function startCount() {
	if (!timer_is_on) {
		timer_is_on = 1;
		timedCount();
	}
}

function stopCount() {
	clearTimeout(temps);
	timer_is_on = 0;
}

function initialiseCompteur() {
	$("#compteur").text('');
	compte = 0; // met le compteur à zéro
	startCount(); // démarre le compteur
}

/*==========================
FENETRES MODALE
============================*/

/* Génération de la fenêtre modale d'information sur La bonne catégorie */
function infosLabonnecategorie() {
	var historique = '';
	historique += '<h4>Version 1.1 <em>(17 septembre 2017)</em></h4>';
	historique += '<ul><li>Mise à jour technique</li><li>Correctifs mineurs</li></ul>';
	historique += '<h4>Version 1.0<em> (5 mars 2017)</em></h4>';
	historique += '<ul><li>22 activités pour une mise en oeuvre immmédiate</li></ul>';
	var fenetre = '<div class="modal-dialog">';
	fenetre += '<div class="modal-content">';
	fenetre += '<div class="modal-header"><button type="button" class="close" data-dismiss="modal">&times;</button><h4 class="modal-title"><img src="images/logo_info_32.png" /> À propos de La Bonne Catégorie...</h4></div>';
	fenetre += '<div class="modal-body">';
	fenetre += '<img style="float:right;" src="images/qrcode_labonnecategorie_128.png"><p>La Bonne Catégorie est une application Web pédagogique multijoueur qui consiste à associer ou à classer des mots, expressions ou nombres selon deux modalités de jeu : fixe ou animée.</p>';
	fenetre += '<p>Compatible avec tous les navigateurs récents, cette application Web HTML5 responsive est développée par Eric Chenavier pour <a target="_blank" href="http://pragmatice.net">PragmaTICE</a>.</p>';
	fenetre += '<p>Gratuitement, sans publicité, et sans avoir à s\'identifier ni à créer de compte, elle est utilisable sur le site de PragmaTICE et téléchargeable pour une utilisation locale <em>(sans connexion Internet)</em>. Toutefois, il est interdit de la mettre en ligne sur d\'autres serveurs, intégralement ou partiellement.</p>';
	fenetre += '<ul><li><a target="_blank" href="http://pragmatice.net/lesite/spip.php?article1257"><b><span class="glyphicon glyphicon-download-alt"></span> Télécharger La Bonne Catégorie</b></a></li> <li><b><a target="_blank" href="http://pragmatice.net/pragmactivites/pragmactivites_menu/index.html"><span class="glyphicon glyphicon-hand-left"></span> Découvrir toutes les pragmactivités</a></b></li> </ul>';
	fenetre += '<p class="pointer plier_deplier_simple lien_a_droite">Historique des versions...</p>';
	fenetre += '<div style="display:none; background-color:#D5D7D6; padding:5px;">'+historique+'</div>';
	fenetre += '</div>';
	fenetre += '<div class="modal-footer" style="text-align:center;">© 2001-2017 PragmaTICE - <a target="_blank" href="http://pragmatice.net/lesite/spip.php?page=contact">Contact</a></div>';
	fenetre += '</div></div></div>';
	$('#modale_infos').html(fenetre).modal();
}

/* Génération de la fenêtre modale Comment jouer sur La bonne catégorie */
function commentJouer() {
	var interets_peda = "<p>Cette application présente les mêmes atouts pédagogiques que toutes les pragmactivités, favorisant ainsi la <a target='_blank' href='http://pragmatice.net/lesite/spip.php?article263'>motivation</a> des élèves et la <a target='_blank' href='http://differenciationpedagogique.com/questceque/questceque'>différenciation</a>&nbsp;:</p>";
	interets_peda += "<ul> <li>un mode multijoueur,</li> <li>une ergonomie adaptée au TNI,</li> <li>des modalités de jeu paramétrables,</li>  <li>la présentation aléatoire des items,</li> <li>des animations dynamiques contextuelles,</li> <li>des rétroactions suivant la réponse du joueur,</li> <li>quelques activités permettant une mise en situation immédiate et intuitive,</li> <li>l'intégration possible de ses propres contenus.</li> </ul>";
	interets_peda += "<p>Les deux modalités de classement se complètent&nbsp;:</p> <ul><li>Le classement fixe permet à l'élève de prendre son temps pour répondre et d'observer les rétroactions qui pourront orienter ses prochains choix.</li> <li>Le classement animé requiert une attention très soutenue de l'élève, qui définit lui-même la difficulté de l'activité selon la vitesse de descente des items.</li></ul>";
	interets_peda += "<p>Dans la présentation classique de l'activité, c'est l'élément choisi par le joueur qui s'affiche comme réponse <em>(en bleu ou en rouge barré)</em>. L'élève pourra s'entraîner, consolider des compétences ciblées, ou encore classer des éléments dans des catégories définies en classe.</p>";
	interets_peda += "<p>Dans la présentation alternative de l'activité, la catégorie et l'élément à classer sont accolés. En reconstituant des mots, l'élève renforcera ses compétences de lecteur, et améliorera son balayage horizontal utile dans les lectures de documents complexes.</p>";
	interets_peda += "<p>L'application propose quelques séries prêtes à être sélectionnées, en Français et en Maths. Toutefois, c'est en privilégiant des contenus personnalisés dans tous les domaines, en lien avec les activités en cours dans la classe, que l'intérêt pédagogique de La Bonne Catégorie sera optimal.</p>";
	var modalites = "<p>L'application peut être utilisée...</p> <ul> <li>sur ordinateur, tablette ou smartphone,</li> <li>en classe, en APC, à la maison,</li> <li>seul, à deux, à trois, par équipe <em>(par exemple au vidéo-projecteur ou au TNI)</em>,</li> <li>pour s'entraîner, consolider des compétences ciblées,</li> <li>pour classer des éléments dans des catégories définies en classe,</li> <li>pour associer deux termes afin par exemple de former un mot,</li> <li>pour mettre en place des situations originales résultant de l'imagination et de l'innovation pédagogique de l'enseignant, qui facilitent la différenciation...</li> </ul>";
	modalites += "<div class='ombre_autour_5' style='padding:5px; font-size:85%; margin:auto; width:95%; background:#FFF;'><p><b>Enregistrer ses activités personnalisées dans un dossier pour pouvoir les importer aisément</b></p> <ol> <li>Importer, saisir, éditer, ou modifier une activité existante.</li> <li><b>*</b> Si le poste est connecté à Internet, cliquer sur <button style='padding:0 5px;' class='btn btn-info btn-sm'><span class='glyphicon glyphicon-export'></span> Exporter</button>, saisir un nom de fichier et valider. <em>(L'activité sera enregistrée dans le dossier des téléchargements du navigateur.)</em></li> <li>Dans l'application, celle-ci pourra être importée à tout moment en cliquant sur le bouton <button style='padding:0 5px;' class='btn btn-info btn-sm'><span class='glyphicon glyphicon-import'></span> Importer</button>.</li> </ol> <p><b>(*)</b> Si le poste n'est pas connecté à Internet :</p><ol><li>Cliquer sur <button style='padding:0 5px;' class='btn btn-info btn-sm'><span class='glyphicon glyphicon-duplicate'></span> Copier</button> <em>(L'activité est automatiquement copiée dans le presse-papier.)</em>.</li> <li>Créer un nouveau document texte dans un dossier préalablement créé <em>(clic droit > Nouveau > Document texte)</em> et le renommer.</li> <li>L'ouvrir, coller l'activité copiée et quitter en enregistrant.</li></ol></div>";
	var textes_dispo = "<p>Quelques séries sont proposées pour une mise en activité immédiate. Toutefois, l'intérêt essentiel de l'application \"La Bonne Catégorie\" est de créer ses propres exercices pour que les élèves s'entraînent sur des notions spécifiquement abordées en classe.</p>";
	textes_dispo += "<h5>Français</h5>";
	textes_dispo += "<p>Les mots sont pour la plupart extraits de <a target='_blank'href='http://eduscol.education.fr/cid50486/liste-de-frequence-lexicale.html'>liste de fréquence lexicale</a> publiée sur Eduscol.</p>";
	textes_dispo += "<ul><li>Adverbes en -ment et -mment</li>";
	textes_dispo += "<li>Connecteurs logiques <em>(But - Comparaison - Conséquence - Cause - Opposition)</em></li>";
	textes_dispo += "<li>Connecteurs spatio-temporels <em>(Espace - Temps)</em></li>";
	textes_dispo += "<li>Genre des noms <em>(Masculin - Féminin)</em></li>";
	textes_dispo += "<li>Groupes des verbes <em>(1er groupe - 2ème groupe - 3ème groupe)</em></li>";
	textes_dispo += "<li>Les petits des animaux</li>";
	textes_dispo += "<li>Mots en -ail, -aille, -âtre, -oir et -oire</li>";
	textes_dispo += "<li>Mots en -ain, -age et -ade</li>";
	textes_dispo += "<li>Mots en -aison, -ation, -ction, -ition et -tion</li>";
	textes_dispo += "<li>Mots en -eau, -et, -ette et -ée</li>";
	textes_dispo += "<li>Mots en -er, -ère, -eur, -euse et -rice</li>";
	textes_dispo += "<li>Mots en -esse, -ité, -ance et -ence</li>";
	textes_dispo += "<li>Mots en -ien, -ienne et -iste</li>";
	textes_dispo += "<li>Nature des mots (1) <em>(Adjectif qualificatif - Adverbe - Nom - Verbe)</em></li>";
	textes_dispo += "<li>Nature des mots (2) <em>(Conjonction - Déterminant - Préposition - Pronom)</em></li>";
	textes_dispo += "<li>Noms féminins en -ce, -ère, -ne, -se, -sse et -tte</li>";
	textes_dispo += "<li>Passé Présent Futur <em>(Verbes conjugués à l'indicatif imparfait, passé composé, présent et futur simple)</em></li>";
	textes_dispo += "<li>Pluriel des noms</li></ul>";
	textes_dispo += "<h5>Maths</h5> <ul><li>Tables d'addition de 2 à 10</li>";
	textes_dispo += "<li>Tables de multiplication de 2 à 5</li>";
	textes_dispo += "<li>Tables de multiplication de 2 à 9</li>";
	textes_dispo += "<li>Tables de multiplication de 5 à 9</li></ul>";
	var fenetre = '<div class="modal-dialog">';
	fenetre += '<div id="div_comment_jouer" class="modal-content">';
	fenetre += '<div class="modal-header"><button id="retour_application" class="btn btn-info btn-xs visible_page no_imprim" style="float:right;"><span class="glyphicon glyphicon-arrow-left"></span> Retour à l\'application</button><button type="button" class="close no_imprim visible_modale" data-dismiss="modal">&times;</button><h4 class="modal-title"><img src="images/logo_comment_jouer_32.png" /> Comment jouer à La Bonne Catégorie ?</h4></div>';
	fenetre += '<div class="modal-body">';
	fenetre += '<h4><img class="pointer visible_page no_imprim" style="float:right" src="images/bt_imprimante_32.png" title="Imprimer" onclick="window.print()"><button id="voir_doc" class="btn btn-info btn-xs visible_modale" style="float:right"><span class="glyphicon glyphicon-book"></span> Documentation complète</button>But du jeu</h4>';
	fenetre += '<p>Associer ou classer des mots, des expressions ou des nombres selon deux modalités de jeu : fixe ou animée.</p>';
	fenetre += "<h4>Choix ou édition de l'activité</h4>";
	fenetre += "<p>L'activité peut être :</p><ul> <li>choisie parmi celles qui sont intégrées à l'application,</li> <li>importée depuis son ordinateur en cliquant sur le bouton <button style='padding:0 5px;' class='btn btn-info btn-sm'><span class='glyphicon glyphicon-import'></span> Importer</button> <em>(si elle a préalablement été exportée ou créée dans un fichier texte),</em></li> <li>saisie dans les champs idoines, éventuellement à l'aide du clavier virtuel <img src='images/logo_clavier_24_on.png' />,</li> <li>éditée en cliquant sur <button class='btn btn-info btn-sm' style='padding:0 5px;'><span class='glyphicon glyphicon-edit'></span> Editer l'activité</button>.</li> </ul>";
	fenetre += '<h4>Déroulement du jeu</h4>';
	fenetre += "<p>Les joueurs peuvent à tout moment saisir leurs prénoms et consulter la consigne. Si elle existe, ils peuvent également consulter l'aide en cliquant sur <span class='glyphicon glyphicon-question-sign'></span> dans le bandeau supérieur.</p> <p>La taille de la police d'écriture peut être modifiée en cliquant sur <span class='glyphicon glyphicon-zoom-out'></span> ou <span class='glyphicon glyphicon-zoom-in'></span>.</p>";
	fenetre += "<p>L’application propose deux modalités de classement : fixe et animé.</p>";
	fenetre += "<h5><span class='glyphicon glyphicon-hand-right'></span> Classement fixe</h5>";
	fenetre += "<img style='float:right; margin-left:10px;' src='images/copie_ecran_fixe.jpg'>";
	fenetre += "<p>Un item aléatoire apparaît. Le joueur clique sur la catégorie à laquelle il appartient.</p>";
	fenetre += "<ul> <li>Si c’est la bonne catégorie, la réponse attendue s’affiche en bleu dans la colonne correspondante, et un nouvel item apparaît.</li> <li>Si ce n’est pas la bonne catégorie, la réponse du joueur s’affiche en rouge barré dans la colonne correspondante, et ce même item est de nouveau proposé.</li> </ul>";	
	fenetre += "<p>Les scores sont comptabilisés en pourcentage de réussite. On change de joueur après chaque catégorie cliquée. La partie se termine lorsque 18 items <em>(ou tous les items si la série en comprend moins de 18)</em> ont été classés.</p>";
	fenetre += "<p>S'affichent en direct dans le bandeau supérieur :</p> <ul> <li>le nombre d'items restant à classer,</li> <li>le temps de jeu de la partie en cours.</li> </ul>";
	fenetre += "<h5><span class='glyphicon glyphicon-hand-right'></span> Classement animé</h5>";
	fenetre += "<img style='float:right; margin:0 0 10px 10px;' src='images/copie_ecran_anime.jpg'>";
	fenetre += "<p>L’application présente une grille de 7 lignes et de 2 à 8 colonnes <em>(une colonne par catégorie)</em>. Dans chaque colonne, la septième ligne contient une catégorie. Au début du jeu, un item aléatoire apparaît dans la première ligne, puis descend de ligne en ligne à une vitesse définie dans le paramétrage du jeu <em>(très lent, lent, moyen, rapide, très rapide, crescendo)</em>.</p> <div style='clear:both;'></div>";
	fenetre += "<p><img style='float:right; margin:0 0 10px 10px;' src='images/copie_ecran_vitesse.jpg'>En cliquant sur les touches <img src='images/touche_gauche_24.png'> et <img src='images/touche_droite_24.png'> de l’écran ou du clavier, le joueur doit déplacer l’item dans la colonne de la catégorie à laquelle il appartient, avant qu’il n’atteigne la septième ligne. Cliquer sur la touche <img src='images/touche_bas_24.png'> permet de valider un choix sans attendre que l’item soit totalement descendu.</p>";
	fenetre += "<ul> <li>Si c’est la bonne catégorie, le joueur marque 1 point, la réponse attendue s'affiche en bleu sous la catégorie, et un nouvel item apparaît.</li> <li>Si ce n’est pas la bonne catégorie, la réponse du joueur s’affiche, barré, dans une case rouge qui devient un obstacle infranchissable, puis il est proposé de nouveau.</li> </ul>";
	fenetre += "<p>La série se termine au bout d'1 minute ou si une case de la première ligne est rouge. On peut alors continuer la même partie <em>(le joueur change le cas échéant et les scores sont conservés)</em> ou recommencer une nouvelle partie.</p>";
	fenetre += "<p>S'affichent en direct dans le bandeau supérieur :</p> <ul> <li>le nombre de secondes restantes,</li> <li>le délai entre chaque changement de ligne, en millisecondes,</li> <li>le temps de jeu de la partie en cours.</li> </ul>";
	fenetre += "<h4>Comment créer ses propres activités ?</h4>";
	fenetre += "<p>Pour être valide, une activité doit comprendre au moins deux catégories contenant chacune au moins un élément. Une consigne et/ou une aide peuvent être saisies dans les champs idoines.</p> <p>Si l'activité comprend plus de 8 catégories, 8 d'entre elles sont tirées au sort et affichées dans l'ordre alphabétique.</p>";
	fenetre += "<h5>1. Définir et saisir les catégories et leurs éléments</h5> <img style='float:right; margin:0 0 10px 10px;' src='images/copie_ecran_editer.jpg' /><p>Ceux-ci peuvent être :</p> <ul> <li>saisis dans le champ principal : une catégorie par ligne, chaque ligne comprenant le nom de la catégorie suivi d'un point-virgule, suivi de chaque élément appartenant à la catégorie, tous séparés par un point-virgule,</li> <li>ou édités en cliquant sur le bouton <button style='padding:0 5px;' class='btn btn-info btn-sm'><span class='glyphicon glyphicon-edit'></span> Editer l'activité</button> : procédure plus conviviale dans laquelle on renseigne un pavé par catégorie avec le nom de la catégorie suivi de ses éléments.</li> </ul>";
	fenetre += "<p><span class='glyphicon glyphicon-hand-right'></span> Cas particulier : accoler la catégorie et l'élément à classer</p> <ul><li>Par défaut, c'est l'élément choisi par le joueur qui s'affiche comme réponse <em>(en bleu ou en rouge barré)</em>.</li> <li>Si la catégorie est en fait la seconde partie d'un mot, il est possible d'afficher comme réponse la catégorie suivie de l'élément choisi par le joueur : faire précéder la catégorie de - et ajouter - à ses premières parties possibles.</li></ul> <p><span class='glyphicon glyphicon-hand-right'></span> Exemples :</p> <ul><li>Catégorie <code>1er groupe</code> et choix du joueur <code>manger</code> affichera comme réponse <code>manger</code>.</li> <li>Catégorie <code>-teau</code> et choix du joueur <code>ba-</code> affichera comme réponse <code>bateau</code>.</li></ul>";
	fenetre += "<h5>2. Saisir éventuellement une consigne et/ou une aide</h5> <p> Une consigne générique s'affiche en l'absence de consigne saisie, et le bouton d'accès à l'aide <span class='glyphicon glyphicon-question-sign'></span> n'apparaît dans le bandeau supérieur que si celle-ci existe.</p> <p>Un retour à la ligne est obtenu en saisissant la balise <code>&lt;br&gt;</code>.</p>";
	fenetre += "<h5>3. Tester l’activité avec le classement fixe ou animé</h5>";
	fenetre += "<h5>4. Enregistrer l’activité en suivant la procédure du paragraphe \"Modalités d’utilisation\"</h5>";
	fenetre += '<h4 class="visible_page">Intérêts pédagogiques</h4><p class="pointer plier_deplier_simple lien_a_droite visible_modale">Intérêts pédagogiques &gt;&gt;&gt;</p>';
	fenetre += '<div style="display:none; background-color:#F2F2F2; padding:5px; margin-bottom:15px;">'+interets_peda+'</div>';
	fenetre += '<h4 class="visible_page">Modalités d\'utilisation</h4><p class="pointer plier_deplier_simple lien_a_droite visible_modale">Modalités d\'utilisation &gt;&gt;&gt;</p>';
	fenetre += '<div style="display:none; background-color:#F2F2F2; padding:5px; margin-bottom:15px;">'+modalites+'</div>';
	fenetre += '<h4 class="visible_page" style="margin-bottom:0; padding-bottom:0;">Activités disponibles</h4><p class="pointer plier_deplier_simple lien_a_droite visible_modale">Activités disponibles &gt;&gt;&gt;</p>';
	fenetre += '<div style="display:none; background-color:#F2F2F2; padding:5px; margin-bottom:15px;">'+textes_dispo+'</div>';
	fenetre += '</div>';
	fenetre += '<div class="modal-footer" style="text-align:center;">© 2001-2017 PragmaTICE - <a target="_blank" href="http://pragmatice.net/lesite/spip.php?page=contact">Contact</a></div>';
	fenetre += '</div></div></div>';
	$('#modale_comment_jouer').html(fenetre).modal();
}

/* Génération de la fenêtre modale Aide dans le jeu */
function aideJeu() {
	var fenetre = '<div class="modal-dialog" data-backdrop="static">';
	fenetre += '<div class="modal-content">';
	fenetre += '<div class="modal-header"><button type="button" class="close" data-dismiss="modal">&times;</button><h4 class="modal-title"><img src="images/logo_aide_32.png" /> Un peu d\'aide ?</h4></div>';
	fenetre += '<div class="modal-body">';
	fenetre += '<p>'+$("#saisie_aide").val()+'</p>';
	fenetre += '</div></div></div>';
	$('#modale_aide_jeu').html(fenetre).modal();
}

/* Génération de la fenêtre modale de choix du temps de réponse pour démarrer le jeu animé */
function modaleTempsReponse() {
	var fenetre = '<div class="modal-dialog" data-backdrop="static">';
	fenetre += '<div class="modal-content">';
	fenetre += '<div class="modal-header"><h4 class="modal-title"><img src="images/logo_choisir_32.png" /> Choisir la vitesse de descente des items</h4></div>';
	fenetre += '<div class="modal-body">';
	fenetre += "<div style='text-align:center' class='commencer_modale'><button class='btn btn-info' data-delai='4000' data-cre='non'><img src='images/logo_tortue.png' /> <img src='images/logo_tortue.png' /> Très lent</button> <button class='btn btn-info' data-delai='3200' data-cre='non'><img src='images/logo_tortue.png' /> Lent</button> <button class='btn btn-info' data-delai='2400' data-cre='non'><img src='images/logo_drapeau.png' /> Moyen</button> <button class='btn btn-info' data-delai='1600' data-cre='non'><img src='images/logo_lapin.png' /> Rapide</button> <button class='btn btn-info' data-delai='800' data-cre='non'><img src='images/logo_lapin.png' /> <img src='images/logo_lapin.png' /> Très rapide</button>  <button class='btn btn-info' style='margin-top:30px;' data-delai='4000' data-cre='oui'><img src='images/logo_tortue.png' /> <img src='images/logo_lapin.png' /> Crescendo</button></div>";
	fenetre += "<p><img src='images/touche_gauche.png' /> <img src='images/touche_bas.png' /> <img src='images/touche_droite.png' /></p>";
	fenetre += "<p>Un mot, une expression ou un nombre va descendre plus ou moins vite. Il faudra cliquer sur les touches <img src='images/touche_gauche_24.png'> et <img src='images/touche_droite_24.png'> de l’écran ou du clavier pour le déplacer dans la colonne de sa catégorie.</p> <p>Cliquer sur la touche <img src='images/touche_bas_24.png'> permet de valider un choix sans attendre que l’item soit totalement descendu.</p>";
	fenetre += "<p>Dans le mode \"Crescendo\", la vitesse augmente de 20% à chaque réussite, jusqu'à ce que le délai entre chaque changement atteigne 431&nbsp;ms.</p>";
	fenetre += "<div style='clear:both;'></div>";
	fenetre += '</div></div></div>';
	$('#modale_tempsdereponse').html(fenetre).modal();
}

/* Génération de la fenêtre modale de saisie du nom de l'activité exportée */
function modaleExport() {
	var fenetre = '<div class="modal-dialog">';
	fenetre += '<div class="modal-content">';
	fenetre += '<div class="modal-header"><button type="button" class="close" data-dismiss="modal">&times;</button><h4 class="modal-title"><img src="images/logo_exporter_32.png" /> Exporter l\'activité</h4></div>';
	fenetre += '<div class="modal-body">';
	fenetre += "<p>L'activité exportée sera enregistrée dans le dossier de téléchargement du navigateur.</p>";
	fenetre += "<p>Cette exportation n'est possible que si le poste est connecté à Internet.</p>";
	fenetre += "<input onKeyPress='if(event.keyCode == 13) exporterTexte();' type='text' id='saisie_nom_fichier' class='form-control claviable' placeholder=\"Saisir le nom de l'activité\" style='background:#F7F7F7' />";
	fenetre += "<div style='text-align:center; margin-top:10px;'><button class='btn btn-info' id='valider_exporter'>Exporter l'activité</button></div>";
	fenetre += '</div></div></div>';
	$('#modale_exporter').html(fenetre).modal();
	$('#modale_exporter').on('shown.bs.modal', function () {
		$(this).find('.form-control:visible:first').focus();
	})
	$('#saisie_nom_fichier').val(nomDuFichier);
	if (clavieractif==true) installVKI();
}

/* Génération de la fenêtre modale d'édition de l'activité avec des colonnes */
function modaleEditerActivite() {
	var lesLignes = $('#saisie_texte').val();
	var tabContenu = lesLignes.split("\n");
	tabContenu = tabContenu.filter( function(val){ return val != '' && val.substring(0,1) != '#' } ); // on ignore les lignes vides et les lignes commençant par #
	$("#edition_colonnes").html('');
	for (i=0 ; i < tabContenu.length ; i++) {
		var tabElements = tabContenu[i].split(";");
		var contenuAvecRetour = "";
		for (j=0 ; j < tabElements.length ; j++) {
			contenuAvecRetour += tabElements[j].trim()+"\n"
		}
		var laColonne = "<div class='col-lg-3 col-md-3 col-sm-3 col-xs-6 col_a_editer'><div> <div><img class='bt_supprimer_col pointer scale_p005' title='Supprimer cette catégorie' src='images/icone_moins_24.png' /> <img class='bt_ajouter_col pointer scale_p005' title='Ajouter une catégorie' src='images/icone_plus_24.png' /></div> <textarea class='form-control claviable' lang='fr' placeholder=\"Saisir un terme par ligne : la catégorie suivie des éléments lui appartenant. Si la catégorie est la seconde partie d'un mot, la faire précéder de - et ajouter - à ses premières parties possibles.\">"+contenuAvecRetour+"</textarea> </div></div>";
		$("#edition_colonnes").append(laColonne);
	}
	if (lesLignes == "") $("#edition_colonnes").html(nouvelleColonne);
	// initialiserVKI();
	if (clavieractif==true) installVKI();
	$('#modale_editer_activite').modal();
}

/*==========================
FONCTIONS AUTRES
============================*/

var clavieractif=false;
/* Activer le clavier virtuel */
function installVKI(){
	clavieractif=true;
	$('.claviable').each(function(){
		var element = $(this)[0];
		element.removeAttribute("VKI_attached");
		VKI_attach(element);
	});
}

/* Desactiver le clavier virtuel */
function desinstallVKI(){
	clavieractif=false;
}

/* Mélanger les éléments d'un tableau https://css-tricks.com/snippets/javascript/shuffle-array/ */
function shuffle(o) {
	for(var j, x, i = o.length; i; j = parseInt(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
	return o;
};

/* Cloner un tableau https://davidwalsh.name/javascript-clone-array */
	Array.prototype.clone = function() {    
		var clone = [];
		for(var i in this)
		{
			clone[i] = this[i]
		}    
		return clone;
	};

/* Remplacer les occurrences http://cwestblog.com/2011/07/25/javascript-string-prototype-replaceall/ */
String.prototype.replaceAll = function(target, replacement) {
  return this.split(target).join(replacement);
};
//alert(chaine.replaceAll("_", "Y"));

/* Supprimer les doublons d'un tableau https://www.unicoda.com/?p=579 */
function cleanArray(array) {
  var i, j, len = array.length, out = [], obj = {};
  for (i = 0; i < len; i++) {
    obj[array[i]] = 0;
  }
  for (j in obj) {
    out.push(j);
  }
  return out;
}
// var nbr = [42, 101010, 7, 42, 7, 42, 101010];
// var newNbr = cleanArray(nbr);
